#ifndef _BTMANAGER_H
#define _BTMANAGER_H

#include <gtkmm/menuitem.h>
#include <libbonobo.h>

#include "GNOME_Bluetooth_Manager.h"
#include <list>

class BluetoothDevice
{
 public:
  BluetoothDevice(Glib::ustring name, Glib::ustring bdaddr);
  Glib::ustring get_name();
  Glib::ustring get_bdaddr();
 protected:
  Glib::ustring _name;
  Glib::ustring _bdaddr;
};

class BluetoothDeviceItem : public Gtk::MenuItem
{
 public:
  BluetoothDeviceItem(const Glib::ustring& label, Glib::ustring name,
		 Glib::ustring bdaddr);
  ~BluetoothDeviceItem();
  BluetoothDevice & get_btdevice();
 protected:
  BluetoothDevice m_btdevice;
};

class BTManager : public SigC::Object
{
 public:
  BTManager();
  ~BTManager();
  bool get_bluetooth_active();
  std::list<BluetoothDeviceItem *> *get_device_list();
  gint get_rfcomm_port(Glib::ustring bdaddr);
  void free_device_list(std::list<BluetoothDeviceItem *> *list);
  void update_device_list();
 protected:
  GNOME_Bluetooth_Manager m_btmanager;  
  CORBA_Environment m_ev;
  bool m_bluetooth_active;
  void set_btmanager(GNOME_Bluetooth_Manager btm);
};

#endif
