#ifndef NO_MAIN

#include <libgnomeuimm.h>
#include <gnome.h>

#include "application.h"

static int test_mode = FALSE;

struct poptOption options[] = {
  {
	"Test",
	't',
	POPT_ARG_NONE,
	&test_mode,
	0,
	N_("Test the phone manager"),
	NULL
  }
};

class PhoneManager : public SigC::Object
{
 public:
  PhoneManager();

 protected:
  // sig handlers

  void session_die();

  bool save_session(gint phase,
					Gnome::UI::SaveStyle save_style,
					bool is_shutdown,
					Gnome::UI::InteractStyle interact_style,
					bool is_fast);

  Gnome::UI::Client* client_;
};

bool
PhoneManager::save_session(gint phase, Gnome::UI::SaveStyle save_style,
            bool is_shutdown, Gnome::UI::InteractStyle interact_style,
            bool is_fast)
{
  std::vector<string> argv(4);
  if (test_mode) {
	argv.push_back("--test");
  }
  client_->set_clone_command(argv);
  client_->set_restart_command(argv);
  return true;
}

void
PhoneManager::session_die()
{
  g_message("quitting session");
}

PhoneManager::PhoneManager() :
    client_(Gnome::UI::Client::master_client())
{
  client_->signal_save_yourself().connect(slot(*this,
											   &PhoneManager::save_session));
  client_->signal_die().connect(slot(*this,
									 &PhoneManager::session_die));
}


int main(int argc, char *argv[])
{
  poptContext pctx;
  PMgrApp* myApp;

  Glib::thread_init();
  gdk_threads_init();


  Gnome::Main gnomeMain("Phone Manager", "0.1",
						Gnome::UI::module_info_get(),
						argc, argv,
						options, 0, &pctx);

  // create session manage client
  PhoneManager client;

  myApp=new PMgrApp();

  gnomeMain.run();

  return 0;
}

#endif
